Gratuitous Neighbor Discovery: Creating Neighbor Cache Entries on First-Hop Routers
RFC 0000
Jen Linkova
Google
1 Darling Island Rd
Pyrmont
NSW
2009
AU
furry@google.com
August 2021
Internet
IPv6 Maintenance
Neighbor Discovery (RFC4861) is used by IPv6 nodes to determine the link-layer addresses of neighboring nodes as well as to discover and maintain reachability information. This document updates RFC4861 to allow routers to proactively create a Neighbor Cache entry when a new IPv6 address is assigned to a node. It also updates RFC4861 and recommends nodes to send unsolicited Neighbor Advertisements upon assigning a new IPv6 address. The proposed change will minimize the delay and packet loss when a node initiates connections to an off-link destination from a new IPv6 address.
Introduction
The Neighbor Discovery state machine defined in [RFC4861] assumes that communications between IPv6 nodes are in most cases bi-directional and if a node A is trying to communicate to its neighbor, node B, the return traffic flows could be expected. So when the node A starts the address resolution process, the target node B would also create an entry containing A's IPv6 and link-layer addresses in its neighbor cache. That entry will be used for sending the return traffic to A.
In particular, Section 7.2.5 of [RFC4861] states:
When a valid Neighbor Advertisement is received (either solicited or unsolicited), the Neighbor Cache is searched for the target's entry. If no entry exists, the advertisement SHOULD be silently discarded. There is no need to create an entry if none exists, since the recipient has apparently not initiated any communication with the target.
While this approach is perfectly suitable for host-to-host on-link communications, it does not work so well when a host sends traffic to off-link destinations. After joining the network and receiving a Router Advertisement the host populates its neighbor cache with the default router IPv6 and link-layer addresses and is able to send traffic to off-link destinations. At the same time the router does not have any cache entries for the host global addresses yet and only starts address resolution upon receiving the first packet of the return traffic flow. While waiting for the resolution to complete routers only keep a very small number of packets in the queue, as recommended in Section 7.2.2 of [RFC4861]. Any additional packets arriving before the resolution > process finishes are likely to result in dropped packets It can cause packet loss and performance degradation that can be user-visible.
This document updates the Neighbor Discovery protocol [RFC4861] to avoid packet loss in the scenario described above. Section 4 discusses the changes and analyses the potential impact, while normative changes to [RFC4861] are specified in Section 6.
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Terminology
Node:
a device that implements IP, [RFC4861].
Host:
any node that is not a router, [RFC4861].
ND:
Neighbor Discovery, [RFC4861].
NC:
Neighbor Cache, [RFC4861]. The Neighbor Cache entry can be in one of five states, as described in Section 7.3.2 of [RFC4861]: INCOMPLETE, REACHABLE, STALE, DELAY, PROBE.
SLAAC:
IPv6 Stateless Address Autoconfiguration, [RFC4862].
NS:
Neighbor Solicitation, [RFC4861].
NA:
Neighbor Advertisement, [RFC4861].
RS:
Router Solicitation, [RFC4861].
RA:
Router Advertisement, [RFC4861].
SLLAO:
Source link-layer Address Option, an option in the ND packets containing the link-layer address of the sender of the packet [RFC4861].
TLLAO:
Target link-layer Address Option, an option in the ND packets containing the link-layer address of the target [RFC4861].
GUA:
Global Unicast Address [RFC4291].
DAD:
Duplicate Address Detection, [RFC4862].
Preferred Address:
an address assigned to an interface whose uniqueness has been verified using DAD and whose use by upper-layer protocols is unrestricted, [RFC4862]. Preferred addresses may be used as the source address of packets sent from the interface.
Optimistic DAD:
a modification of DAD, [RFC4429].
Problem Statement
The most typical scenario when the problem may arise is a host joining the network, forming a new address and using that address for accessing the Internet:
1. A host joins the network and receives a Router Advertisement (RA) packet from the first-hop router (either a periodic unsolicited RA or a response to a Router Solicitation sent by the host). The RA contains information the host needs to perform SLAAC and to configure its network stack. The RA is sent from the router's link-local address to a link-local destination address and may contain the link-layer address of the router. As a result the host can populate its Neighbor Cache with the router's link-local and link-layer addresses.
2. The host starts opening connections to off-link destinations. A very common use case is a mobile device sending probes to detect the Internet connectivity and/or the presence of a captive portal on the network. To speed up that process many implementations use Optimistic DAD which allows them to send probes before the DAD process is completed. At that moment the device neighbor cache contains all information required to send those probes (such as the default router link-local and link-layer addresses). The router neighbor cache, however, might contain an entry for the device link-local address (if the device has been performing the address resolution for the router link-local address), but there are no entries for any of the device's global addresses.
3. Return traffic is received by the first-hop router. As the router does not have any cache entry for the host global address yet, the router starts the neighbor discovery process by creating an INCOMPLETE cache entry and then sending a Neighbor Solicitation to the Solicited Node Multicast Address (Section 7.3.2 of [RFC4861]). As per Section 7.2.2 of [RFC4861] Routers MUST buffer at least one data packet and MAY buffer more, while resolving the packet destination address. However, most router implementations limit the buffer size to a few packets only, and some implementations are known to buffer just one packet. So any subsequent packets arriving before the address resolution process is completed are causing packet loss by replacing older packets in the buffer.
4. If the host sends multiple probes in parallel, in the worst case, it would consider all but one of them failed. That leads to user-visible delay in connecting to the network, especially if the host implements some form of backoff mechanism and does not retransmit the probes as soon as possible.
This scenario illustrates the problem occurring when the device connects to the network for the first time or after an inactivity period long enough for the device address to be removed from the router's neighbor cache. However, the same sequence of events happen when the host starts using a new global address previously unseen by the router, such as a new privacy address [RFC8981] or if the router's Neighbor Cache has been flushed.
While in dual-stack networks this problem might be hidden by Happy Eyeballs [RFC8305] it manifests quite clearly in IPv6-only environments, especially wireless ones, leading to poor user experience and contributing to a negative perception of IPv6-only solutions as unstable and non-deployable.
Solution Requirements
It would be highly desirable to improve the Neighbor Discovery mechanics so routers have a usable cache entry for a host address by the time the router receives the first packet for that address. In particular:
- If the router does not have a Neighbor Cache entry for the address, a STALE entry needs to be created proactively, prior to arrival of the first packet intended for that address.
- The solution needs to work for Optimistic addresses as well. Devices implementing the Optimistic DAD usually attempt to minimize the delay in connecting to the network and therefore are more likely to be affected by the problem described in this document.
- In case of duplicate addresses present in the network, the proposed solution should not override the existing entry.
- In topologies with multiple first-hop routers the cache needs to be updated on all of them, as traffic might be asymmetric: outgoing flows leaving the network via one router while the return traffic enters the segment via another one.
In addition the solution must not exacerbate issues described in [RFC6583] and needs to be compatible with the recommendations provided in [RFC6583].
Changes to Neighbor Discovery
The following changes are required to minimize the delay in creating new entries in a router neighbor cache
- A node sends unsolicited NAs upon assigning a new IPv6 address to its interface.
- A router creates a new cache entry upon receiving an unsolicited NA from a host.
The following sections discuss these changes in more detail. Normative changes are specified in Section 6.
Nodes Sending Gratuitous Neighbor Advertisements
The Section 7.2.6 of [RFC4861] discusses using unsolicited Neighbor Advertisements to inform node neighbors of the new link-layer address quickly. The same mechanism could be used to notify the node neighbors about the new network-layer address as well: the node can send gratuitous unsolicited Neighbor Advertisements upon assigning a new IPv6 address to its interface.
To minimize the potential disruption in case of duplicate addresses the node should not set the Override flag for a preferred address and must not set the Override flag if the address is in Optimistic [RFC4429] state.
As the main purpose of sending unsolicited NAs upon configuring a new address is to proactively create a Neighbor Cache entry on the first-hop routers, the gratuitous NAs are sent to the all-routers multicast address (ff02::2). Limiting the recipients to routers only would help reduce the multicast noise level. If the link-layer devices are performing MLD snooping [RFC4541], then those unsolicited NAs will be only sent to routers on the given network segment/link, instead of being flooded to all nodes.
It should be noted that the proposed mechanism does not cause any significant increase in multicast traffic. The additional multicast unsolicited NA would proactively create a STALE cache entry on routers as discussed below. When the router receives the return traffic flows it does not need to send multicast NSes to the solicited node multicast address but would be sending unicast NSes instead. Therefore this procedure would only produce an increase in the overall amount of multicast traffic if no return traffic arrives for the address that sent the unsolicited NA or if the router does not create a STALE entry upon receiving such NA. The increase would be negligible as that additional traffic is a few orders of magnitude less than the usual level of Neighbor Discovery multicast traffic.
Routers Creating Cache Entries Upon Receiving Unsolicited Neighbor Advertisements
The Section 7.2.5 of [RFC4861] states:
When a valid Neighbor Advertisement is received (either solicited or unsolicited), the Neighbor Cache is searched for the target's entry. If no entry exists, the advertisement SHOULD be silently discarded. There is no need to create an entry if none exists, since the recipient has apparently not initiated any communication with the target.
The reasoning behind dropping unsolicited Neighbor Advertisements ("the recipient has apparently not initiated any communication with the target") is valid for onlink host-to-host communication but, as discussed above, it does not really apply for the scenario when the host is announcing its address to routers. Therefore, it would be beneficial to allow routers to create new entries upon receiving an unsolicited Neighbor Advertisement.
This document updates [RFC4861] so that routers create a new Neighbor Cache entry upon receiving an unsolicited Neighbor Advertisement for an address that does not already have a Neighbor Cache entry. . The proposed changes do not modify routers behaviour specified in [RFC4861] for the scenario when the corresponding Neighbor Cache entry already exists.
The next section analyses various scenarios of duplicated addresses and discusses the potential impact of creating a STALE entry for a duplicated IPv6 address.
Avoiding Disruption
If nodes following the recommendations in this document are using the DAD mechanism defined in [RFC4862], they would send unsolicited NA as soon as the address changes the state from tentative to preferred (after its uniqueness has been verified). However, nodes willing to minimize network stack configuration delays might be using optimistic addresses, which means there is a possibility of the address not being unique on the link. Section 2.2 of [RFC4429] discusses measures to ensure that ND packets from the optimistic address do not override any existing neighbor cache entries as it would cause traffic interruption of the rightful address owner in case of address conflict. As nodes willing to speed up their network stack configuration are most likely to be affected by the problem outlined in this document it seems reasonable for such hosts to advertise their optimistic addresses by sending unsolicited NAs. The main question to consider is the potential risk of overriding the cache entry for the rightful address owner if the optimistic address happens to be duplicated.
The following sections discuss the address collision scenario when a node sends an unsolicited NA for an address in the Optimistic state, while another node (the rightful owner) has the same address assigned already. This document uses the term "the rightful owner" as the same terminology is used in [RFC4429]. The analysis assumes that the host performs Duplicate Address Detection, as Section 5.4 of [RFC4862] requires that DAD MUST be performed on all unicast addresses prior to assigning them to an interface.
Neighbor Cache Entry Exists in Any State Other Than INCOMPLETE
If the router Neighbor Cache entry for the target address already exists in any state other than INCOMPLETE, then as per Section 7.2.5 of [RFC4861] an unsolicited NA with the Override flag cleared would change the entry state from REACHABLE to STALE but would not update the entry in any other way. Therefore, even if the host sends an unsolicited NA from its Optimistic address the router cache entry would not be updated with the new Link-Layer address and no impact to the traffic for the rightful address owner is expected.
The return traffic intended for the host with the Optimistic address would be sent to the rightful owner. However, this is unavoidable with or without the unsolicited NA mechanism.
Neighbor Cache Entry is in INCOMPLETE state
Another corner case is the INCOMPLETE cache entry for the address.
1. The router receives a packet for the rightful owner of the address.
2. The router starts the address resolution process by creating an INCOMPLETE entry and sends the multicast NS.
3. More packets arrive at the router for the address in question.
4. The host configures an Optimistic address and sends an unsolicited NA.
5. The router creates a STALE entry and sends the buffered packet(s) to the host (while at least some of those packets are actually intended for the rightful owner).
6. As the STALE entry was used to send packets, the router changes the entry state to DELAY and waits up to DELAY_FIRST_PROBE_TIME ([RFC4861], 5 secs) before sending unicast NS.
7. The rightful owner responds to the multicast NS sent at Step 2 with a solicited NA with the Override flag set.
8. The router updates the entry with the TLLAO supplied (the rightful owner link-layer address) and sets the entry state to REACHABLE (as the NA has the Solicited flag set).
As a result some packets (ones in the buffer at Step 6 and all packets arriving between Step 6 and Step 8) are delivered to the host with the Optimisitc address, while some of them, if not all, are intended for the rightful owner. Without the unsolicited NA, packet which are in the buffer at Step 8 (usually just one packet but some routers may buffer a few) would have been delivered to the rightful owner and the rest of the packets would have been dropped. However, the probability of such scenario is rather low as it would require the following things to happen almost simultaneously (within tens of milliseconds in most cases):
- One host starts using a new IPv6 address and sending traffic without sending an unsolicited NA first.
- Another host configures the same IPv6 address in Optimistic mode before the router completes the address resolution for the rightful owner.
It should be noted that in this scenario the rigthful owner does not send any unsolicited NAs before sending packets. If the rightful owner implements the functionality described in this document and sends unsolicited NAs upon configuring its address, then the router creates a STALE entry for the address, causing all packets are delivered to the rightful owner (see Section 5.1). The rightful owner would experience no disruption but might receive some packets intended for the host with Optimistic address.
This section focuses on the scenario when the solicited NA from the rightful owner arrives after the unsolicited one sent from the Optimistic address (Step 7 and Step 4 respectively). If the solicited NA arrives first it changes the NC entry state from INCOMPLETE to REACHABLE. As discussed in Section 5.1, there will be no disruption for the rightful owner if the router already has a REACHABLE entry for the address when an unsolicited NA is received.
Neighbor Cache Entry Does Not Exist
There are two distinct scenarios which can lead to the situation when the router does not have a NC entry for the IPv6 address:
1. The rightful owner of the address has not been using it for off-link communication recently or has never used it at all.
2. The rightful owner just started sending packets from that address but the router has not received any return traffic yet.
The impact on the rightful owner's traffic flows would be different in those cases.
The Rightful Owner Is Not Sending Packets From The Address
In this scenario the following events are expected to happen:
1. The host configures the address and sets its state to Optimistic.
2. The host sends an unsolicited NA with the Override flag set to zero and starts sending traffic from the Optimistic address.
3. The router creates a STALE entry for the address and the host link-layer address.
4. The host starts DAD and detects the address duplication.
5. The router receives the return traffic for the duplicated address. As the NC entry is STALE it sends traffic using that entry, changes it to DELAY and waits up to DELAY_FIRST_PROBE_TIME ([RFC4861]) seconds.
6. The router changes the NC entry state to PROBE and sends up to MAX_UNICAST_SOLICIT ([RFC4861]) unicast NSes separated by RetransTimer milliseconds ([RFC4861]) to the host link-layer address.
7. As the host has detected the address conflict already it does not respond to the unicast NSes. (It is unlikely that the host has not completed the DAD process at this stage, as DELAY_FIRST_PROBE_TIME (5 seconds) is much higher than the DAD duration (DupAddrDetectTransmits*RetransTimer*1000 + MAX_RTR_SOLICITATION_DELAY secs, Section 5.4 of [RFC4862]). The default value for the DAD process would be 1*1*1000 + 1 = 2 secs, [RFC4861]. If the host has completed DAD but did not detect the address conflict then there are two hosts with the same address in the Preferred state and the disruption is inevitable anyway.
8. As the router receives no response for the unicast NSes, it deletes the NC entry.
9. If return packets for communication initiated at step 2 are still arriving, the router buffers a small number of those packets and starts the address resolution again by sending a multicast NS to the solicited node multicast address. The rightful owner responds and the router NC entry is updated with the rightful owner link-local address. The buffered packet(s) are sent to that address. Any packets still arriving after the address resolution still completed are sent to the rightful address owner as well.
The rightful owner is not experiencing any disruption as it does not send any traffic. It would only start receiving packets intended for another host after Step 8 is completed and only if return packets for the communication initiated at step 2 are still arriving.
However, the same behaviour would be observed if changes proposed in this document are not implemented. If the host starts sending packets from its Optimistic address but then changes the address state to Duplicated, the first return packet would trigger the address resolution process and would be buffered until the resolution is completed. The buffered packet(s) and any packets still arriving after the address is resolved would be forwarded to the rightful owner of the address. So the rightful owner might still receive one or more packets from the flows intended for another host. Therefore, it's safe to conclude that the proposed changes do introduce any disruption for the rightful owner of the duplicated address.
The Rightful Owner Has Started Sending Packets From The Address
In this scenario the following events are happening:
1. The rightful owner starts sending traffic from the address (e.g. the address has just been configured or has not been recently used).
2. The host configures the address and sets its state to Optimistic.
3. The host sends an unsolicited NA with the Override flag set to zero and starts sending traffic from the Optimistic address.
4. The router creates a STALE entry for the address and the host link-layer address.
5. The host starts DAD and detects the address duplication.
6. The router receives the return traffic for the IPv6 address in question. Some flows intended for the rightful owner of the duplicated address, while some are for the new host. As the NC entry is STALE it sends traffic using that entry, changes it to DELAY and waits up to DELAY_FIRST_PROBE_TIME ([RFC4861]) seconds.
7. The router changes the NC entry state to PROBE and sends up to MAX_UNICAST_SOLICIT ([RFC4861]) unicast NSes separated by RetransTimer milliseconds ([RFC4861]) to the host link-layer address.
8. As the host has detected the address conflict already it does not respond to the unicast NSes.
9. As the router receives no response for the unicast NSes, it deletes the NC entry.
10. The next packet re-creates the entry and triggers the resolution process. The router buffers the packet and sends a multicast NS to the solicited node multicast address. The rightful owner responds and the router NC entry is updated with the rightful owner link-local address.
As a result the traffic for the address rightful owner would be sent to the host with the duplicated address instead. The duration of the disruption can be estimated as DELAY_FIRST_PROBE_TIME*1000 + (MAX_UNICAST_SOLICIT - 1)*RetransTimer milliseconds. As per the constants defined in Section 10 of [RFC4861] this interval is equal to 5*1000 + (3 - 1)*1000 = 7000ms or 7 seconds.
However, it should be noted that the probability of such scenario is rather low. Similary to the scenario discussed in Section 5.2, it would require the following things to happen almost simultaneously (within tens of milliseconds in most cases):
- One host starts using a new IPv6 address and sending traffic without sending an unsolicited NA first.
- Another host configures the same IPv6 address in Optimistic mode before the router receives the return traffic for the first host.
As discussed in Section 5.2, the disruption to the rightful owner can easily be prevent if that node implements the mechanism described in the document. Sending unsolicited NAs before initiatining off-link communication would create a STALE entry in the router NC and prevent any tarffic to that address to be sent to the host with the Optimistic address (see Section 5.1).
Modifications to RFC-Mandated Behavior
All normative text in this memo is contained in this section.
Modification to RFC4861 Neighbor Discovery for IP version 6 (IPv6)
Modification to the section 7.2.5
This document makes the following changes to the Section 7.2.5 of [RFC4861]:
OLD TEXT:
When a valid Neighbor Advertisement is received (either solicited or unsolicited), the Neighbor Cache is searched for the target's entry. If no entry exists, the advertisement SHOULD be silently discarded. There is no need to create an entry if none exists, since the recipient has apparently not initiated any communication with the target.
NEW TEXT:
When a valid Neighbor Advertisement is received (either solicited or unsolicited), the Neighbor Cache is searched for the target's entry. If no entry exists:
- Hosts SHOULD silently discard the advertisement. There is no need to create an entry if none exists, since the recipient has apparently not initiated any communication with the target.
- Routers SHOULD create a new entry for the target address with the link-layer address set to the Target link-layer address option (if supplied). The entry's reachability state MUST be set to STALE. If the received Neighbor Advertisement does not contain the Target link-layer address option the advertisement SHOULD be silently discarded.
Modification to the section 7.2.6
This document proposes the following changes to the Section 7.2.6 of [RFC4861]:
OLD TEXT:
Also, a node belonging to an anycast address MAY multicast unsolicited Neighbor Advertisements for the anycast address when the node's link-layer address changes.
NEW TEXT:
Also, a node belonging to an anycast address MAY multicast unsolicited Neighbor Advertisements for the anycast address when the node's link-layer address changes.
A node may also wish to notify its first-hop routers when it configures a new global IPv6 address so the routers can proactively populate their neighbor caches with the corresponding entries. In such cases a node SHOULD send up to MAX_NEIGHBOR_ADVERTISEMENT Neighbor Advertisement messages. If the address is preferred then the Override flag SHOULD NOT be set. If the address is in the Optimistic state then the Override flag MUST NOT be set. The destination address SHOULD be set to the all-routers multicast address. These advertisements MUST be separated by at least RetransTimer seconds. The first advertisement SHOULD be sent as soon as one of the following events happens:
if Optimistic DAD [RFC4429] is used:
a new Optimistic address is assigned to the node interface.
if Optimistic DAD is not used:
an address changes the state from tentative to preferred.
Solution Limitations
The solution described in this document provides some improvement for a node configuring a new IPv6 address and starting sending traffic from it. However, that approach does not completely eliminate the scenario when a router receives some transit traffic for an address without the corresponding Neighbor Cache entry. For example:
- If the host starts using an already configured IPv6 address after a long period of inactivity, the router might not have the NC entry for that address anymore, as old/expired entries are deleted.
- Clearing the router Neighbor Cache would trigger the packet loss for all actively used addresses removed from the cache.
Solutions Considered but Discarded
There are other possible approaches to address the problem, for example:
- Just do nothing.
- Migrating from the "reactive" Neighbor Discovery ([RFC4861]) to the registration-based mechanisms ([RFC8505]).
- Creating new entries in routers Neighbor Cache by gleaning from Neighbor Discovery DAD messages.
- Initiates bidirectional communication from the host to the router using the host GUA.
- Making the probing logic on hosts more robust.
- Increasing the buffer size on routers.
- Transit dataplane traffic from an unknown address (an address w/o the corresponding neighbor cache entry) triggers an address resolution process on the router.
It should be noted that some of those options are already implemented by some vendors. The following sections discuss those approaches and the reasons they were discarded.
Do Nothing
One of the possible approaches might be to declare that everything is working as intended and let the upper-layer protocols deal with packet loss. The obvious drawbacks include:
- Unhappy users.
- Many support tickets.
- More resistance to deploy IPv6 and IPv6-Only networks.
Change to the Registration-Based Neighbor Discovery
The most radical approach would be to move away from the reactive ND as defined in [RFC4861] and expand the registration-based ND ([RFC6775], [RFC8505]) used in Low-Power Wireless Personal Area Networks (6LoWPANs) to the rest of IPv6 deployments. This option requires some investigation and discussion. However, significant changes to the existing IPv6 implementations would be needed, so unclear adoption timeline makes this approach less preferable than one proposed in this document.
Host Sending NS to the Router Address from Its GUA
The host could force creating a STALE entry for its GUA in the router ND cache by sending the following Neighbor Solicitation message:
- The NS source address is the host GUA.
- The destination address is the default router IPv6 address.
- The Source Link-Layer Address option contains the host link-layer address.
- The target address is the host default router address (the default router address the host received in the RA).
The main disadvantages of this approach are:
- Would not work for Optimistic addresses as Section 2.2 of [RFC4429] explicitly prohibits sending Neighbor Solicitations from an Optimistic Address.
- If first-hop redundancy is deployed in the network, the NS would reach the active router only, so all backup routers (or all active routers except one) would not get their neighbor cache updated.
- Some wireless devices are known to alter ND packets and perform various non-obvious forms of ND proxy actions. In some cases, unsolicited NAs might not even reach the routers.
Host Sending Router Solicitation from its GUA
The host could send a router solicitation message to 'all routers' multicast address, using its GUA as a source. If the host link-layer address is included in the Source Link-Layer Address option, the router would create a STALE entry for the host GUA as per the Section 6.2.6 of [RFC4861]. However, this approach cannot be used if the GUA is in optimistic state: Section 2.2 of [RFC4429] explicitly prohibits using an Optimistic Address as the source address of a Router Solicitation with a SLLAO as it might disrupt the rightful owner of the address in the case of a collision. So for the optimistic addresses the host can send an RS without SLLAO included. In that case the router may respond with either a multicast or a unicast RA (only the latter would create a cache entry).
This approach has the following drawbacks:
- If the address is in the Optimistic state the RS cannot contain SLLAO. As a result the router would only create a cache entry if solicited RAs are sent as unicast. Routers sending solicited RAs as multicast would not create a new cache entry as they do not need to send a unicast packet back to the host.
- There might be a random delay between receiving an RS and sending a unicast RA back (and creating a cache entry) which might undermine the idea of creating the cache entry proactively.
- Some wireless devices are known to intercept ND packets and perform various non-obvious forms of ND proxy actions. In some cases the RS might not even reach the routers.
Routers Populating Their Caches by Gleaning From Neighbor Discovery Packets
Routers may be able to learn about new addresses by gleaning from the DAD Neighbor Solicitation messages. The router could listen to all solicited node multicast address groups and upon receiving a Neighbor Solicitation from the unspecified address search its Neighbor Cache for the solicitation's Target Address. If no entry exists, the router may create an entry, set its reachability state to 'INCOMPLETE' and start the address resolution for that entry.
The same solution was proposed in [I-D.halpern-6man-nd-pre-resolve-addr]. Some routing vendors support such optimization already. However, this approach has a number of drawbacks and therefore should not be used as the only solution:
- Routers need to receive all multicast Neighbor Discovery packets which might negatively impact the routers CPU.
- If the router starts the address resolution as soon as it receives the DAD Neighbor Solicitation the host might be still performing DAD and the target address might be tentative. In that case, the host SHOULD silently ignore the received Neighbor Solicitation from the router as per the Section 5.4.3 of [RFC4862]. As a result the router might not be able to complete the address resolution before the return traffic arrives.
Initiating Hosts-to-Routers Communication
The host may force the router to start address resolution by sending a data packet such as ping or traceroute to its default router link-local address, using the GUA as a source address. As the RTT to the default router is lower than RTT to any off-link destinations it's quite likely that the router would start the neighbor discovery process for the host GUA before the first packet of the returning traffic arrives.
This approach has the following drawbacks:
- Data packets to the router link-local address could be blocked by security policy or control plane protection mechanism.
- It introduces an additional overhead for routers control plane (in addition to processing ND packets, the data packet needs to be processed as well).
- Unless the data packet is sent to 'all routers' ff02::2 multicast address, if the network provides a first-hop redundancy then only the active router would create a new cache entry.
Making the Probing Logic on Hosts More Robust
Theoretically the probing logic on hosts might be modified to deal better with initial packet loss. For example, only one probe can be sent or probes retransmit intervals can be reduced. However, this approach has a number of drawbacks:
- It would require updating all possible applications performing probing, while the proposed solution is implemented on operating systems level.
- Some implementations need to send multiple probes. Examples include but not limited to:
  - Sending AAAA and A records DNS probes in parallel.
  - Detecting captive portals often require sending multiple packets.
- While it would increase the probability of the probing to complete successfully, there are multiple cases when packet loss would still occur:
  - The probe response consists of multiple packets, so all but the first one are dropped.
  - There are multiple applications on the same host sending traffic and return packets arrive simultaneously.
  - There are multiple first-hop routers in the network. The first probe packet creates the NC entry on one of them. The subsequent return traffic flows might cross other routers and still experience the issue.
- Reducing the probe retransmit interval unnecessary increases the network utilization and might cause the network congestion.
Increasing the Buffer Size on Routers
Increasing the buffer size and buffering more packets would exacerbate issues described in [RFC6583] and make the router more vulnerable to ND-based denial of service attacks.
Transit Dataplane Traffic From a New Address Triggering Address Resolution
When a router receives a transit packet sourced by a on-link neighbor node, it might check the presence of the neighbor cache entry for the packet source address and if the entry does not exist, start address resolution process. This approach does ensure that a Neighbor Cache entry is proactively created every time a new, previously unseen GUA is used for sending offlink traffic. However, this approach has a number of limitations, in particular:
- If traffic flows are asymmetrical the return traffic might not transit the same router as the original traffic which triggered the address resolution. So the neighbor cache entry is created on the "wrong" router, not the one which actually needs the neighbor cache entry for the host address.
- The functionality needs to be limited to explicitly configured networks/interfaces, as the router needs to distinguish between onlink addresses (ones the router needs to have Neighbor Cache entries for) and the rest of the address space. The proactive address resolution must only be triggered by packets from the prefixes known to be on-link. Otherwise, traffic from spoofed source addresses or any transit traffic could lead to neighbor cache exhaustion.
- Implementing such functionality is much more complicated than all other solutions as it would involve complex data-control planes interaction.
IANA Considerations
This memo asks the IANA for no new parameters.
Security Considerations
One of the potential attack vectors to consider is a cache spoofing when the attacker might try to install a cache entry for the victim's IPv6 address and the attacker's Link-Layer address. However, it should be noted that this document does not propose any changes for the scenario when the ND cache for the given IPv6 address already exists. Therefore, there are no new vectors for an attacker to override an existing cache entry.
Section 5 describes some corner cases when a host with the duplicated Optimistic address might get some packets intended for the rightful owner of the address. However such scenarios do not introduce any new attack vectors: even without the proposed changes, an attacker can easily override the routers neighbor cache and redirect the traffic by sending NAs with the Solicited flag set. As discussed in Section 5.3.2 the worst case scenario might cause a disruption for up to 7 seconds. This risk is considered acceptable due to very low probability of that scenario. More importantly, for all cases described in Section 5 the rightful owner can prevent disruption caused by an accidental address duplication just by implementing the mechanism described in this document. If the rightful owner sends unsolicited NAs before using the address, the STALE entry would be created on the router NC and any subsequent unsolicited NAs sent from the host with an Optimistic address would not override the NC entry.
A malicious host could attempt to exhaust the neighbor cache on the router by creating a large number of STALE entries. However, this attack vector is not new and this document does not increase the risk of such an attack: the attacker could do it, for example, by sending a NS or RS packet with SLLAO included. All recommendations from [RFC6583] still apply.
Announcing a new address to all-routers multicast address may inform an on-link attacker about IPv6 addresses assigned to the host. However, hiding information about the specific IPv6 address should not be considered a security measure as such information is usually disclosed via DAD to all nodes anyway if MLD snooping is not enabled. Network administrators can also mitigate this issue by enabling MLD snooping on the link-layer devices to prevent IPv6 link-local multicast packets being flooded to all onlink nodes. If peer-to-peer onlink communications are not desirable for the given network segment they should be prevented by proper layer-2 security mechanisms. Therefore, the risk of allowing hosts to send unsolicited Neighbor Advertisements to all-routers multicast address is low.
It should be noted that the proposed mechanism allows hosts to proactively inform their routers about global IPv6 addresses existing on-link. Routers could use that information to distinguish between used and unused addresses to mitigate ND cache exhaustion DoS attacks described in Section 4.3.2 of [RFC3756] and [RFC6583].
Acknowledgements
Thanks to the following people (in alphabetical order) for their comments, review and feedback: Mikael Abrahamsson, Stewart Bryant, Lorenzo Colitti, Roman Danyliw, Owen DeLong, Martin Duke, Igor Gashinsky, Carles Gomez, Fernando Gont, Tatuya Jinmei, Benjamin Kaduk, Scott Kelly, Erik Kline, Warren Kumari, Barry Leiba, Jordi Palet Martinez, Erik Nordmark, Michael Richardson, Dan Romascanu, Zaheduzzaman Sarker, Michael Scharf, John Scudder, Mark Smith, Dave Thaler, Pascal Thubert, Loganaden Velvindron, Eric Vyncke.
References
Normative References
Informative References
[RFC4861]
[RFC2119]
[RFC8174]
[RFC4862]
[RFC4291]
[RFC4429]
[RFC8981]
[RFC8305]
[RFC6583]
[RFC4541]
[RFC8505]
[RFC6775]
[I-D.halpern-6man-nd-pre-resolve-addr]
[RFC3756]